#!/bin/bash
#modified for Fedora 8 **only** - experimental!!

prepare_for_non_debian() {
    # check that we have the tools we need to build kernel modules...
    which make >/dev/null 2>&1
    make_result=$?
    which gcc >/dev/null 2>&1
    gcc_result=$?
    if [ $make_result != 0 -o $gcc_result != 0 ]
      then
        echo "You need to have installed both make and gcc, aborting..."
        exit 1
    fi
}

#note that this procedure is not called, but has been left for reference
complete_redhat_installation() {
    VAR=$1
  if [ $VAR = 61 ]
    then
      device=wlan0
      text="# RaLink RT2561/RT61 802.11g PCI\nDEVICE=wlan0\nONBOOT=no\nBOOTPROTO=dhcp\n# HWADDR=00:00:00:00:00:00\nTYPE=Wireless\nUSERCTL=yes\n"
    else
      device=wlan0
      text="# RaLink RT2761/RT73 802.11g USB\nDEVICE=wlan0\nONBOOT=no\nBOOTPROTO=dhcp\n# HWADDR=00:00:00:00:00:00\nTYPE=Wireless\nUSERCTL=yes\n"
  fi
  cfg_file=/etc/sysconfig/network-scripts/ifcfg-$device
  if [ ! -f $cfg_file ]
    then
      echo -e "$text" >$cfg_file
      ln -f $cfg_file /etc/sysconfig/networking/devices
      ln -f $cfg_file /etc/sysconfig/networking/profiles/default
  fi
  grep -q 'NOZEROCONF' /etc/sysconfig/network
  if [ $? != 0 ]
    then
      echo "NOZEROCONF=yes" >>/etc/sysconfig/network
  fi
}

platform=unknown

if [ -f /etc/redhat-release ]
  then
    platform=redhat
    prepare_for_non_debian;
fi

if [ $platform = unknown ]
  then
    echo "We don't appear to be running on Fedora 8, aborting..."
    exit 1
fi

while true
  do
    echo -e "Choose Ralink driver to install:

	1. RT61 - for PCI and PCMCIA cards
	2. RT73 - for USB dongles

	Choose 1 or 2 (q quits) \c"
    read reply
    echo
    case x$reply in
      xq | xQ ) exit 0
                ;;
           x1 ) variant=61
                break
                ;;
           x2 ) variant=73
                break
                ;;
            * ) echo "Please choose 1, 2 or q"
                ;;
    esac
  done

set -e

export variant
case $variant in
  61 ) tarfile=rt61-cvs-2007112109.tar.gz
       srcdir=rt61-cvs-2007112109/Module
       ;;
  73 ) tarfile=rt73-cvs-2007121004.tar.gz
       srcdir=rt73-cvs-2007121004/Module
       ;;
   * ) echo "variant must be 61 or 73"
       exit 1
       ;;
esac

currdir=`pwd`
tar xvzf $tarfile
cd $srcdir

make clean; rm -f Modules.symvers *.ko rt${variant}.mod.c
make
strip -S rt${variant}.ko
echo "stripped"
make install

cd $currdir
set +e

if [ $variant = 73 ]
  then
    bad_module=rt73usb
  else
    bad_module=rt61pci
fi

grep -q 'blacklist $bad_module' /etc/modprobe.d/blacklist
if [ $? != 0 ]
  then
    echo "blacklist $bad_module" >>/etc/modprobe.d/blacklist
fi

#complete_redhat_installation $variant
