#!/bin/bash

prepare_for_gutsy() {
    # make sure we have the tools we need to build kernel modules...
    apt-get install build-essential
    kern=`uname -r`
    apt-get install linux-headers-$kern
}


add_to_blacklist()  {
    grep -q $item ${file}
    if [ $? != 0 ]
        then
            echo "blacklist ${item}" >>${file}
        fi
}

complete_gutsy_installation()	{
	
    device=wlan0
    badmodule=(rt2500usb rt73usb ipv6 rt2570 rt2x00lib b43)
    file=/etc/modprobe.d/blacklist

    for item in ${badmodule[*]}
    do
        add_to_blacklist
    done

}

platform=unknown

grep -q 'Ubuntu 7.10' /etc/issue
if [ $? = 0 ]
	then
		platform=gutsy
fi

if [ $platform = gutsy ]
	then
		prepare_for_gutsy;
fi

if [ $platform = unknown ]
  then
    echo "We don't appear to be running on Ubuntu Gutsy. aborting..."
    exit 1
fi

set -e

tarfile=rt73-cvs-2007100810.tar.gz
srcdir=rt73-cvs-2007100810/Module

currdir=`pwd`
tar xvzf $tarfile
cd $srcdir

make clean; rm -f Modules.symvers *.ko rt${variant}.mod.c
make
strip -S rt73.ko
echo "stripped"
make install

cd $currdir
set +e

complete_gutsy_installation
                                                      
